diff -ruN strongswan-5.8.4/src/libcharon/sa/ike_sa.c strongswancont-5.8.4-svc/src/libcharon/sa/ike_sa.c
--- strongswan-5.8.4/src/libcharon/sa/ike_sa.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ike_sa.c	2023-06-15 15:43:27.206585000 +0300
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2006-2019 Tobias Brunner
+ * Copyright (C) 2006-2020 Tobias Brunner
  * Copyright (C) 2006 Daniel Roethlisberger
  * Copyright (C) 2005-2009 Martin Willi
  * Copyright (C) 2005 Jan Hutter
@@ -65,6 +65,10 @@
 #include <processing/jobs/initiate_mediation_job.h>
 #endif
 
+#ifdef _WIN32
+#include <windows.h>
+#endif /* _WIN32 */
+
 ENUM(ike_sa_state_names, IKE_CREATED, IKE_DESTROYING,
 	"CREATED",
 	"CONNECTING",
@@ -237,6 +241,12 @@
 	uint32_t keepalive_interval;
 
 	/**
+	 * Time the NAT keep alive interval may be exceeded before triggering a DPD
+	 * instead of a NAT keep alive
+	 */
+	uint32_t keepalive_dpd_margin;
+
+	/**
 	 * The scheduled keep alive job, if any
 	 */
 	send_keepalive_job_t *keepalive_job;
@@ -655,7 +665,19 @@
 
 	diff = now - last_out;
 
-	if (diff >= this->keepalive_interval)
+	if (this->keepalive_dpd_margin &&
+		diff > (this->keepalive_interval + this->keepalive_dpd_margin))
+	{
+		if (!this->task_manager->busy(this->task_manager))
+		{
+			DBG1(DBG_IKE, "sending DPD instead of keep alive %ds after last "
+				 "outbound message", diff);
+			this->task_manager->queue_dpd(this->task_manager);
+			this->task_manager->initiate(this->task_manager);
+		}
+		diff = 0;
+	}
+	else if (diff >= this->keepalive_interval)
 	{
 		packet_t *packet;
 		chunk_t data;
@@ -669,6 +691,7 @@
 		packet->set_data(packet, data);
 		DBG1(DBG_IKE, "sending keep alive to %#H", this->other_host);
 		charon->sender->send_no_marker(charon->sender, packet);
+		this->stats[STAT_OUTBOUND] = now;
 		diff = 0;
 	}
 	if (!this->keepalive_job)
@@ -934,6 +957,17 @@
 	{
 		charon->ike_sa_manager->new_initiator_spi(charon->ike_sa_manager,
 												  &this->public);
+
+		/* when starting from scratch, connect to the original peer again e.g.
+		 * if we got redirected but weren't able to connect successfully */
+		if (this->redirected_from)
+		{
+			this->redirected_from->destroy(this->redirected_from);
+			this->redirected_from = NULL;
+			/* we can't restore the original value, if there was any */
+			DESTROY_IF(this->remote_host);
+			this->remote_host = NULL;
+		}	
 	}
 	/* the responder ID is reset, as peer may choose another one */
 	if (this->ike_sa_id->is_initiator(this->ike_sa_id))
@@ -2145,6 +2179,19 @@
 		return FAILED;
 	}
 
+#ifdef _WIN32
+	int delay = lib->settings->get_int(lib->settings, "%s.create_ike_delay",
+								   0, lib->ns);
+	if (delay > 0)
+	{
+		if (delay > 10000)
+		{
+			delay = 10000;
+		}		
+		SleepEx(delay, TRUE);
+	}
+#endif /* _WIN32 */
+
 	new = charon->ike_sa_manager->checkout_new(charon->ike_sa_manager,
 											   this->version, TRUE);
 	if (!new)
@@ -2287,9 +2334,9 @@
 	reset(this, TRUE);
 	DESTROY_IF(this->redirected_from);
 	this->redirected_from = this->other_host->clone(this->other_host);
-	DESTROY_IF(this->remote_host);
 	/* this allows us to force the remote address while we still properly
 	 * resolve the local address */
+	DESTROY_IF(this->remote_host);
 	this->remote_host = other;
 	resolve_hosts(this);
 	return TRUE;
@@ -2396,81 +2443,86 @@
 	{
 		return INVALID_STATE;
 	}
-	this->stats[STAT_OUTBOUND] = time_monotonic(NULL);
-	if (this->task_manager->retransmit(this->task_manager, message_id) != SUCCESS)
+	switch (this->task_manager->retransmit(this->task_manager, message_id))
+	{
+		case SUCCESS:
+			this->stats[STAT_OUTBOUND] = time_monotonic(NULL);
+			return SUCCESS;
+		case INVALID_STATE:
+			return INVALID_STATE;
+		default:
+			break;
+	}
+	/* send a proper signal to brief interested bus listeners */
+	switch (this->state)
 	{
-		/* send a proper signal to brief interested bus listeners */
-		switch (this->state)
+		case IKE_CONNECTING:
 		{
-			case IKE_CONNECTING:
-			{
-				/* retry IKE_SA_INIT/Main Mode if we have multiple keyingtries */
-				uint32_t tries = this->peer_cfg->get_keyingtries(this->peer_cfg);
-				charon->bus->alert(charon->bus, ALERT_PEER_INIT_UNREACHABLE,
-								   this->keyingtry);
-				this->keyingtry++;
-				if (tries == 0 || tries > this->keyingtry)
-				{
-					DBG1(DBG_IKE, "peer not responding, trying again (%d/%d)",
-						 this->keyingtry + 1, tries);
-					reset(this, TRUE);
-					resolve_hosts(this);
-					return this->task_manager->initiate(this->task_manager);
-				}
-				DBG1(DBG_IKE, "establishing IKE_SA failed, peer not responding");
-
-				if (this->version == IKEV1 && array_count(this->child_sas))
+			/* retry IKE_SA_INIT/Main Mode if we have multiple keyingtries */
+			uint32_t tries = this->peer_cfg->get_keyingtries(this->peer_cfg);
+			charon->bus->alert(charon->bus, ALERT_PEER_INIT_UNREACHABLE,
+							   this->keyingtry);
+			this->keyingtry++;
+			if (tries == 0 || tries > this->keyingtry)
+			{
+				DBG1(DBG_IKE, "peer not responding, trying again (%d/%d)",
+					 this->keyingtry + 1, tries);
+				reset(this, TRUE);
+				resolve_hosts(this);
+				return this->task_manager->initiate(this->task_manager);
+			}
+			DBG1(DBG_IKE, "establishing IKE_SA failed, peer not responding");
+
+			if (this->version == IKEV1 && array_count(this->child_sas))
+			{
+				enumerator_t *enumerator;
+				child_sa_t *child_sa;
+
+				/* if reauthenticating an IKEv1 SA failed (assumed for an SA
+				 * in this state with CHILD_SAs), try again from scratch */
+				DBG1(DBG_IKE, "reauthentication failed, trying to "
+					 "reestablish IKE_SA");
+				reestablish(this);
+				/* trigger down events for the CHILD_SAs, as no down event
+				 * is triggered below for IKE SAs in this state */
+				enumerator = array_create_enumerator(this->child_sas);
+				while (enumerator->enumerate(enumerator, &child_sa))
 				{
-					enumerator_t *enumerator;
-					child_sa_t *child_sa;
-
-					/* if reauthenticating an IKEv1 SA failed (assumed for an SA
-					 * in this state with CHILD_SAs), try again from scratch */
-					DBG1(DBG_IKE, "reauthentication failed, trying to "
-						 "reestablish IKE_SA");
-					reestablish(this);
-					/* trigger down events for the CHILD_SAs, as no down event
-					 * is triggered below for IKE SAs in this state */
-					enumerator = array_create_enumerator(this->child_sas);
-					while (enumerator->enumerate(enumerator, &child_sa))
+					if (child_sa->get_state(child_sa) != CHILD_REKEYED &&
+						child_sa->get_state(child_sa) != CHILD_DELETED)
 					{
-						if (child_sa->get_state(child_sa) != CHILD_REKEYED &&
-							child_sa->get_state(child_sa) != CHILD_DELETED)
-						{
-							charon->bus->child_updown(charon->bus, child_sa,
-													  FALSE);
-						}
+						charon->bus->child_updown(charon->bus, child_sa,
+												  FALSE);
 					}
-					enumerator->destroy(enumerator);
 				}
-				break;
+				enumerator->destroy(enumerator);
 			}
-			case IKE_DELETING:
-				DBG1(DBG_IKE, "proper IKE_SA delete failed, peer not responding");
-				if (has_condition(this, COND_REAUTHENTICATING) &&
-					!lib->settings->get_bool(lib->settings,
-										"%s.make_before_break", FALSE, lib->ns))
-				{
-					DBG1(DBG_IKE, "delete during reauthentication failed, "
-						 "trying to reestablish IKE_SA anyway");
-					reestablish(this);
-				}
-				break;
-			case IKE_REKEYING:
-				DBG1(DBG_IKE, "rekeying IKE_SA failed, peer not responding");
-				/* FALL */
-			default:
-				reestablish(this);
-				break;
-		}
-		if (this->state != IKE_CONNECTING &&
-			this->state != IKE_REKEYED)
-		{
-			charon->bus->ike_updown(charon->bus, &this->public, FALSE);
+			break;
 		}
-		return DESTROY_ME;
+		case IKE_DELETING:
+			DBG1(DBG_IKE, "proper IKE_SA delete failed, peer not responding");
+			if (has_condition(this, COND_REAUTHENTICATING) &&
+				!lib->settings->get_bool(lib->settings,
+									"%s.make_before_break", FALSE, lib->ns))
+			{
+				DBG1(DBG_IKE, "delete during reauthentication failed, "
+					 "trying to reestablish IKE_SA anyway");
+				reestablish(this);
+			}
+			break;
+		case IKE_REKEYING:
+			DBG1(DBG_IKE, "rekeying IKE_SA failed, peer not responding");
+			/* FALL */
+		default:
+			reestablish(this);
+			break;
 	}
-	return SUCCESS;
+	if (this->state != IKE_CONNECTING &&
+		this->state != IKE_REKEYED)
+	{
+		charon->bus->ike_updown(charon->bus, &this->public, FALSE);
+	}
+	return DESTROY_ME;
 }
 
 METHOD(ike_sa_t, set_auth_lifetime, status_t,
@@ -2678,6 +2730,14 @@
 			this->task_manager->queue_mobike(this->task_manager, FALSE, TRUE);
 			return this->task_manager->initiate(this->task_manager);
 		}
+		if (lib->settings->get_bool(lib->settings,
+								"%s.check_current_path", FALSE, lib->ns) &&
+			!this->task_manager->busy(this->task_manager))
+		{
+			DBG1(DBG_IKE, "checking if current path still works using DPD");
+			this->task_manager->queue_dpd(this->task_manager);
+			return this->task_manager->initiate(this->task_manager);
+		}
 		return SUCCESS;
 	}
 
@@ -3171,6 +3231,8 @@
 		.unique_id = ref_get(&unique_id),
 		.keepalive_interval = lib->settings->get_time(lib->settings,
 								"%s.keep_alive", KEEPALIVE_INTERVAL, lib->ns),
+		.keepalive_dpd_margin = lib->settings->get_time(lib->settings,
+								"%s.keep_alive_dpd_margin", 0, lib->ns),
 		.retry_initiate_interval = lib->settings->get_time(lib->settings,
 								"%s.retry_initiate_interval", 0, lib->ns),
 		.flush_auth_cfg = lib->settings->get_bool(lib->settings,
diff -ruN strongswan-5.8.4/src/libcharon/sa/ike_sa.h strongswancont-5.8.4-svc/src/libcharon/sa/ike_sa.h
--- strongswan-5.8.4/src/libcharon/sa/ike_sa.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ike_sa.h	2022-07-06 15:47:34.526979000 +0300
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2006-2019 Tobias Brunner
+ * Copyright (C) 2006-2020 Tobias Brunner
  * Copyright (C) 2006 Daniel Roethlisberger
  * Copyright (C) 2005-2009 Martin Willi
  * Copyright (C) 2005 Jan Hutter
@@ -872,10 +872,11 @@
 	 *
 	 * @param message_id	ID of the request to retransmit
 	 * @return
-	 *						- SUCCESS
-	 *						- NOT_FOUND if request doesn't have to be retransmitted
+	 *						- SUCCESS if retransmit was sent
+	 *						- INVALID_STATE if no retransmit required
+	 *						- DESTROY_ME if this IKE_SA MUST be deleted
 	 */
-	status_t (*retransmit) (ike_sa_t *this, uint32_t message_id);
+	status_t (*retransmit)(ike_sa_t *this, uint32_t message_id);
 
 	/**
 	 * Sends a DPD request to the peer.
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/authenticators/pubkey_v1_authenticator.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/authenticators/pubkey_v1_authenticator.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/authenticators/pubkey_v1_authenticator.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/authenticators/pubkey_v1_authenticator.c	2022-07-06 15:47:34.530979000 +0300
@@ -84,6 +84,10 @@
 	{
 		scheme = SIGN_ECDSA_WITH_NULL;
 	}
+	else if (this->type == KEY_BIGN)
+	{
+		scheme = SIGN_BIGN_WITH_HBELT;
+	}
 
 	id = this->ike_sa->get_my_id(this->ike_sa);
 	auth = this->ike_sa->get_auth_cfg(this->ike_sa, TRUE);
@@ -171,6 +175,10 @@
 	{
 		scheme = SIGN_ECDSA_WITH_NULL;
 	}
+	else if (this->type == KEY_BIGN)
+	{
+		scheme = SIGN_BIGN_WITH_HBELT;
+	}
 
 	sig_payload = (hash_payload_t*)message->get_payload(message, PLV1_SIGNATURE);
 	if (!sig_payload)
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/keymat_v1.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/keymat_v1.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/keymat_v1.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/keymat_v1.c	2022-07-06 15:47:34.566980000 +0300
@@ -288,6 +288,9 @@
 			return HASH_SHA512;
 		case AUTH_HMAC_MD5_96:
 			return HASH_MD5;
+		case AUTH_BELT_HASH_LEGACY:
+		case AUTH_BELT_HASH:
+			return BELT_HASH;	
 		default:
 			return HASH_UNKNOWN;
 	}
@@ -391,6 +394,7 @@
 		case AUTH_XAUTH_RESP_RSA:
 		case AUTH_HYBRID_INIT_RSA:
 		case AUTH_HYBRID_RESP_RSA:
+		case AUTH_BIGN:
 		{
 			if (!this->prf->set_key(this->prf, nonces) ||
 				!this->prf->allocate_bytes(this->prf, g_xy, &skeyid))
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/phase1.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/phase1.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/phase1.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/phase1.c	2022-07-06 15:47:34.510979000 +0300
@@ -143,11 +143,10 @@
 
 	if (peer_cfg)
 	{	/* as initiator or aggressive responder, use identities */
-		my_auth = get_auth_cfg(peer_cfg, TRUE);
 		other_auth = get_auth_cfg(peer_cfg, FALSE);
-		if (my_auth && other_auth)
+		if (other_auth)
 		{
-			my_id = my_auth->get(my_auth, AUTH_RULE_IDENTITY);
+			my_id = this->ike_sa->get_my_id(this->ike_sa);
 			if (peer_cfg->use_aggressive(peer_cfg))
 			{
 				other_id = this->ike_sa->get_other_id(this->ike_sa);
@@ -156,10 +155,7 @@
 			{
 				other_id = other_auth->get(other_auth, AUTH_RULE_IDENTITY);
 			}
-			if (my_id)
-			{
-				shared_key = find_shared_key(my_id, me, other_id, other);
-			}
+			shared_key = find_shared_key(my_id, me, other_id, other);
 		}
 	}
 	else
@@ -445,6 +441,9 @@
 								break;
 						}
 						break;
+					case KEY_BIGN:
+						method = AUTH_BIGN;
+						break;
 					default:
 						DBG1(DBG_IKE, "private key of type %N not supported",
 							 key_type_names, private->get_type(private));
@@ -476,8 +475,10 @@
 	{
 		if (i2 == AUTH_CLASS_ANY && r2 == AUTH_CLASS_ANY)
 		{
-			/* for any pubkey method, return RSA */
-			return AUTH_RSA;
+			/* for any pubkey method, return based on pubkey method */
+			auth_method_t m = get_pubkey_method(this,
+				get_auth_cfg(peer_cfg, TRUE));
+			return (m == AUTH_BIGN) ? AUTH_BIGN : AUTH_RSA;
 		}
 		if (i2 == AUTH_CLASS_XAUTH)
 		{
@@ -629,6 +630,7 @@
 			if (!me->is_anyaddr(me))
 			{
 				id = identification_create_from_sockaddr(me->get_sockaddr(me));
+				auth = this->ike_sa->get_auth_cfg(this->ike_sa, TRUE);
 				auth->add(auth, AUTH_RULE_IDENTITY, id);
 			}
 		}
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/task_manager_v1.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/task_manager_v1.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/task_manager_v1.c	2019-08-27 16:26:53.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/task_manager_v1.c	2022-07-06 15:47:34.570980000 +0300
@@ -199,6 +199,14 @@
 	 */
 	u_int retransmit_tries;
 
+ 	/**
+	 * Maximum number of tries possible with current retransmission settings
+	 * before overflowing the range of uint32_t, which we use for the timeout.
+	 * Note that UINT32_MAX milliseconds equal nearly 50 days, so that doesn't
+	 * make much sense without retransmit_limit anyway.
+	 */
+	u_int retransmit_tries_max;
+
 	/**
 	 * Retransmission timeout
 	 */
@@ -355,7 +363,7 @@
 							u_int mid, u_int retransmitted, array_t *packets)
 {
 	packet_t *packet;
-	uint32_t t, max_jitter;
+	uint32_t t = UINT32_MAX, max_jitter;
 
 	array_get(packets, 0, &packet);
 	if (retransmitted > this->retransmit_tries)
@@ -364,8 +372,12 @@
 		charon->bus->alert(charon->bus, ALERT_RETRANSMIT_SEND_TIMEOUT, packet);
 		return DESTROY_ME;
 	}
-	t = (uint32_t)(this->retransmit_timeout * 1000.0 *
-					pow(this->retransmit_base, retransmitted));
+	if (!this->retransmit_tries_max ||
+		retransmitted <= this->retransmit_tries_max)
+	{
+		t = (uint32_t)(this->retransmit_timeout * 1000.0 *
+						pow(this->retransmit_base, retransmitted));
+	}
 	if (this->retransmit_limit)
 	{
 		t = min(t, this->retransmit_limit);
@@ -392,7 +404,7 @@
 METHOD(task_manager_t, retransmit, status_t,
 	private_task_manager_t *this, uint32_t seqnr)
 {
-	status_t status = SUCCESS;
+	status_t status = INVALID_STATE;
 
 	if (seqnr == this->initiating.seqnr &&
 		array_count(this->initiating.packets))
@@ -2141,5 +2153,11 @@
 	}
 	this->dpd_send &= 0x7FFFFFFF;
 
+	if (this->retransmit_base > 1)
+	{	/* based on 1000 * timeout * base^try */
+		this->retransmit_tries_max = log(UINT32_MAX/
+										 (1000.0 * this->retransmit_timeout))/
+									 log(this->retransmit_base);
+	}
 	return &this->public;
 }
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_cert_post.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_cert_post.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_cert_post.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_cert_post.c	2022-07-06 15:47:34.566980000 +0300
@@ -82,6 +82,7 @@
 				case AUTH_XAUTH_RESP_RSA:
 				case AUTH_HYBRID_INIT_RSA:
 				case AUTH_HYBRID_RESP_RSA:
+				case AUTH_BIGN:
 					use = TRUE;
 					break;
 				default:
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_cert_pre.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_cert_pre.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_cert_pre.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_cert_pre.c	2022-07-06 15:47:34.526979000 +0300
@@ -99,8 +99,7 @@
 	id = certreq->get_dn(certreq);
 	if (!id)
 	{
-		DBG1(DBG_IKE, "ignoring certificate request without data",
-			 certificate_type_names, certreq->get_cert_type(certreq));
+		DBG1(DBG_IKE, "ignoring certificate request without data");
 		return NULL;
 	}
 	cert = lib->credmgr->get_cert(lib->credmgr, CERT_X509, KEY_ANY, id, TRUE);
@@ -421,6 +420,7 @@
 				case AUTH_ECDSA_521:
 				case AUTH_XAUTH_INIT_RSA:
 				case AUTH_XAUTH_RESP_RSA:
+				case AUTH_BIGN:
 					use = TRUE;
 					break;
 				default:
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_vendor.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_vendor.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/isakmp_vendor.c	2018-10-23 20:03:28.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/isakmp_vendor.c	2022-07-06 15:47:34.570980000 +0300
@@ -112,6 +112,10 @@
 	{ "FRAGMENTATION", EXT_IKE_FRAGMENTATION, FALSE, 20,
 	  "\x40\x48\xb7\xd5\x6e\xbc\xe8\x85\x25\xe7\xde\x7f\x00\xd6\xc2\xd3\x80\x00\x00\x00"},
 
+	/* Using EXT_STRONGSWAN extension flag to unlock private algorithms */
+	{ "BY-STB Cryptography", EXT_STRONGSWAN, TRUE, 16,
+	  "\xfe\xe9\x32\xef\xe1\x02\x15\xf9\xad\x3c\x3c\xe5\x93\x8a\x5d\x79"},
+
 	/* Windows peers send this VID and a version number */
 	{ "MS NT5 ISAKMPOAKLEY", EXT_MS_WINDOWS, FALSE, 20,
 	  "\x1e\x2b\x51\x69\x05\x99\x1c\x7d\x7c\x96\xfc\xbf\xb5\x87\xe4\x61\x00\x00\x00\x00"},
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/main_mode.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/main_mode.c
--- strongswan-5.8.4/src/libcharon/sa/ikev1/tasks/main_mode.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev1/tasks/main_mode.c	2022-07-06 15:47:34.566980000 +0300
@@ -302,8 +302,14 @@
 		}
 		case MM_SA:
 		{
+			identification_t *id;
 			uint16_t group;
 
+			/* we might need the identity to look up a PSK when processing the
+			 * response */
+			id = this->ph1->get_id(this->ph1, this->peer_cfg, TRUE);
+			this->ike_sa->set_my_id(this->ike_sa, id->clone(id));
+
 			if (!this->ph1->create_hasher(this->ph1))
 			{
 				return send_notify(this, NO_PROPOSAL_CHOSEN);
@@ -331,8 +337,7 @@
 			id_payload_t *id_payload;
 			identification_t *id;
 
-			id = this->ph1->get_id(this->ph1, this->peer_cfg, TRUE);
-			this->ike_sa->set_my_id(this->ike_sa, id->clone(id));
+			id = this->ike_sa->get_my_id(this->ike_sa);
 			id_payload = id_payload_create_from_identification(PLV1_ID, id);
 			message->add_payload(message, &id_payload->payload_interface);
 
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/authenticators/eap_authenticator.c	2022-07-06 15:47:34.566980000 +0300
@@ -305,10 +305,28 @@
 				this->method->destroy(this->method);
 				return server_initiate_eap(this, FALSE);
 			}
-			if (this->method->get_msk(this->method, &this->msk) == SUCCESS)
-			{
-				this->msk = chunk_clone(this->msk);
-			}
+			switch (this->method->get_msk(this->method, &this->msk))
+ 			{
+				case SUCCESS:
+					this->msk = chunk_clone(this->msk);
+					if(type == EAP_BSTS || type == EAP_BPACE) 
+					{
+						chunk_t skd;
+						keymat_v2_t *keymat;
+
+						keymat = (keymat_v2_t*)this->ike_sa->get_keymat(this->ike_sa);
+						keymat->get_skd(keymat, &skd);
+
+						memmove(skd.ptr, this->msk.ptr, skd.len);
+					}
+					break;
+				case NOT_SUPPORTED:
+					break;
+				case FAILED:
+				default:
+					DBG1(DBG_IKE, "failed to establish MSK");
+					goto failure;
+ 			}
 			if (vendor)
 			{
 				DBG1(DBG_IKE, "EAP vendor specific method %d-%d succeeded, "
@@ -326,6 +344,7 @@
 			return eap_payload_create_code(EAP_SUCCESS, in->get_identifier(in));
 		case FAILED:
 		default:
+failure:
 			/* type might have changed for virtual methods */
 			type = this->method->get_type(this->method, &vendor);
 			if (vendor)
@@ -661,11 +680,37 @@
 				uint32_t vendor;
 				auth_cfg_t *cfg;
 
-				if (this->method->get_msk(this->method, &this->msk) == SUCCESS)
-				{
-					this->msk = chunk_clone(this->msk);
-				}
 				type = this->method->get_type(this->method, &vendor);
+
+				if (!this->method)
+ 				{					
+					DBG1(DBG_IKE, "received unexpected %N",
+						 eap_code_names, eap_payload->get_code(eap_payload));
+					return FAILED;
+				}
+				switch (this->method->get_msk(this->method, &this->msk))
+				{
+					case SUCCESS:					
+						this->msk = chunk_clone(this->msk);
+						if(type == EAP_BSTS || type == EAP_BPACE) 
+						{
+							chunk_t skd;
+							keymat_v2_t *keymat =  
+								(keymat_v2_t*)this->ike_sa->get_keymat(this->ike_sa);
+							keymat->get_skd(keymat, &skd);
+
+							memmove(skd.ptr, this->msk.ptr, skd.len);
+						}
+						break;
+					case NOT_SUPPORTED:
+						break;
+					case FAILED:
+					default:
+						DBG1(DBG_IKE, "received %N but failed to establish MSK",
+							 eap_code_names, eap_payload->get_code(eap_payload));
+						return FAILED;
+ 				}
+
 				if (vendor)
 				{
 					DBG1(DBG_IKE, "EAP vendor specific method %d-%d succeeded, "
@@ -747,6 +792,7 @@
 	DESTROY_IF(this->eap_payload);
 	DESTROY_IF(this->eap_identity);
 	chunk_free(&this->msk);
+	DBG4(DBG_LIB,"Освобожден сессионный ключ");
 	free(this);
 }
 
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/authenticators/pubkey_authenticator.c	2022-07-06 15:47:34.582980000 +0300
@@ -270,6 +270,13 @@
 				}
 			}
 		}
+		else if (key_type == KEY_BIGN) {
+			scheme = SIGN_BIGN_WITH_HBELT;
+			INIT(config,
+				.scheme = scheme,
+			)
+			array_insert(selected, ARRAY_TAIL, config);
+		}
 	}
 	return selected;
 }
@@ -442,6 +449,10 @@
 			scheme = SIGN_RSA_EMSA_PKCS1_SHA1;
 			auth_method = AUTH_RSA;
 			break;
+		case KEY_BIGN:
+			scheme = SIGN_BIGN_WITH_HBELT;
+			auth_method = AUTH_BIGN;
+			break;	
 		case KEY_ECDSA:
 			/* deduct the signature scheme from the keysize */
 			switch (private->get_keysize(private))
@@ -601,6 +612,10 @@
 			key_type = KEY_RSA;
 			params->scheme = SIGN_RSA_EMSA_PKCS1_SHA1;
 			break;
+		case AUTH_BIGN:
+			key_type = KEY_BIGN;
+			params->scheme = SIGN_BIGN_WITH_HBELT;
+			break;
 		case AUTH_ECDSA_256:
 			params->scheme = SIGN_ECDSA_256;
 			break;
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/keymat_v2.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/keymat_v2.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/keymat_v2.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/keymat_v2.c	2022-07-06 15:47:34.570980000 +0300
@@ -73,6 +73,21 @@
 	chunk_t skp_verify;
 
 	/**
+	 * Key transformer to update skd(msk) (optional)
+	 */
+	key_transformer_t *transformer;
+
+	/**
+	 * skd(msk) level needed by transformer
+	 */
+	chunk_t level;
+
+	/**
+	 * sdk(msk) header needed by transformer
+	 */
+	chunk_t header;	
+
+	/**
 	 * Set of hash algorithms supported by peer for signature authentication
 	 */
 	hash_algorithm_set_t *hash_algorithms;
@@ -306,7 +321,7 @@
 	chunk_t skeyseed = chunk_empty, key, secret, full_nonce, fixed_nonce;
 	chunk_t prf_plus_seed, spi_i, spi_r;
 	prf_plus_t *prf_plus = NULL;
-	uint16_t alg, key_size, int_alg;
+	uint16_t alg, key_tfm_alg, key_size, int_alg;
 	prf_t *rekey_prf = NULL;
 
 	spi_i = chunk_alloca(sizeof(uint64_t));
@@ -335,6 +350,35 @@
 		chunk_clear(&secret);
 		return FALSE;
 	}
+
+	/* Create key transformer if proposed */
+	if (proposal->get_algorithm(proposal, KEY_TRANSFORM_ALGORITHM,
+								&key_tfm_alg, NULL))
+	{
+		DBG1(DBG_IKE, "%N proposed",
+			 transform_type_names, KEY_TRANSFORM_ALGORITHM);
+
+		this->transformer = 
+			lib->crypto->create_key_transformer(lib->crypto, key_tfm_alg);
+
+		if (this->transformer == NULL)
+		{
+			DBG1(DBG_IKE, "%N %N not supported!",
+				 transform_type_names, KEY_TRANSFORM_ALGORITHM,
+				 key_transform_algorithm_names, key_tfm_alg);
+			chunk_clear(&secret);
+			return FALSE;
+		}
+
+		/* allocating level */
+		this->level = chunk_alloc(12);
+		memwipe(this->level.ptr, this->level.len);
+
+		/* allocating header */
+		this->header = chunk_alloc(16);
+		memwipe(this->header.ptr, this->header.len);
+	}
+
 	DBG4(DBG_IKE, "shared Diffie Hellman secret %B", &secret);
 	/* full nonce is used as seed for PRF+ ... */
 	full_nonce = chunk_cat("cc", nonce_i, nonce_r);
@@ -651,6 +695,26 @@
 		int_size /= 8;
 	}
 
+	/* update skd(msk) if transformer presents */
+	if (this->transformer)
+	{
+		DBG2(DBG_CHD, "  updating SK_d");
+		DBG4(DBG_CHD, "SK_d %B", &this->skd);
+
+		if(!this->transformer->transform(this->transformer,
+			this->skd, this->skd, this->level, this->header))
+		{
+			DBG1(DBG_CHD, "  updating SK_d failed");
+			return FALSE;
+		}
+
+		DBG4(DBG_CHD, "updated SK_d %B", &this->skd);
+
+		/* increment level by 1 */
+		int k;
+		for(k = 0; (k < 12) && (0 == ++this->level.ptr[k]); k++);
+	}
+
 	if (!this->prf->set_key(this->prf, this->skd))
 	{
 		return FALSE;
@@ -839,9 +903,12 @@
 	DESTROY_IF(this->aead_in);
 	DESTROY_IF(this->aead_out);
 	DESTROY_IF(this->prf);
+	DESTROY_IF(this->transformer);
 	chunk_clear(&this->skd);
 	chunk_clear(&this->skp_verify);
 	chunk_clear(&this->skp_build);
+	chunk_clear(&this->level);
+	chunk_clear(&this->header);
 	DESTROY_IF(this->hash_algorithms);
 	free(this);
 }
@@ -874,6 +941,9 @@
 		},
 		.initiator = initiator,
 		.prf_alg = PRF_UNDEFINED,
+		.transformer = NULL,
+		.level = chunk_empty,
+		.header = chunk_empty,
 	);
 
 	return &this->public;
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/task_manager_v2.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/task_manager_v2.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/task_manager_v2.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/task_manager_v2.c	2023-06-15 15:45:21.029345000 +0300
@@ -103,6 +103,12 @@
 		 */
 		u_int retransmitted;
 
+ 		/**
+		 * TRUE if any retransmits have been sent for this message (counter is
+		 * reset if deferred)
+		 */
+		bool retransmit_sent;
+
 		/**
 		 * packet(s) for retransmission
 		 */
@@ -150,6 +156,14 @@
 	 */
 	u_int retransmit_tries;
 
+ 	/**
+	 * Maximum number of tries possible with current retransmission settings
+	 * before overflowing the range of uint32_t, which we use for the timeout.
+	 * Note that UINT32_MAX milliseconds equal nearly 50 days, so that doesn't
+	 * make much sense without retransmit_limit anyway.
+	 */
+	u_int retransmit_tries_max;
+
 	/**
 	 * Retransmission timeout
 	 */
@@ -331,7 +345,7 @@
 	if (message_id == this->initiating.mid &&
 		array_count(this->initiating.packets))
 	{
-		uint32_t timeout, max_jitter;
+		uint32_t timeout = UINT32_MAX, max_jitter;
 		job_t *job;
 		enumerator_t *enumerator;
 		packet_t *packet;
@@ -357,22 +371,7 @@
 
 		if (!mobike || !mobike->is_probing(mobike))
 		{
-			if (this->initiating.retransmitted <= this->retransmit_tries)
-			{
-				timeout = (uint32_t)(this->retransmit_timeout * 1000.0 *
-					pow(this->retransmit_base, this->initiating.retransmitted));
-
-				if (this->retransmit_limit)
-				{
-					timeout = min(timeout, this->retransmit_limit);
-				}
-				if (this->retransmit_jitter)
-				{
-					max_jitter = (timeout / 100.0) * this->retransmit_jitter;
-					timeout -= max_jitter * (random() / (RAND_MAX + 1.0));
-				}
-			}
-			else
+			if (this->initiating.retransmitted > this->retransmit_tries)
 			{
 				DBG1(DBG_IKE, "giving up after %d retransmits",
 					 this->initiating.retransmitted - 1);
@@ -380,13 +379,28 @@
 								   packet);
 				return DESTROY_ME;
 			}
-
+			if (!this->retransmit_tries_max ||
+				this->initiating.retransmitted <= this->retransmit_tries_max)
+			{
+				timeout = (uint32_t)(this->retransmit_timeout * 1000.0 *
+					pow(this->retransmit_base, this->initiating.retransmitted));
+			}
+			if (this->retransmit_limit)
+			{
+				timeout = min(timeout, this->retransmit_limit);
+			}
+			if (this->retransmit_jitter)
+			{
+				max_jitter = (timeout / 100.0) * this->retransmit_jitter;
+				timeout -= max_jitter * (random() / (RAND_MAX + 1.0));
+			}
 			if (this->initiating.retransmitted)
 			{
 				DBG1(DBG_IKE, "retransmit %d of request with message ID %d",
 					 this->initiating.retransmitted, message_id);
 				charon->bus->alert(charon->bus, ALERT_RETRANSMIT_SEND, packet,
 								   this->initiating.retransmitted);
+				this->initiating.retransmit_sent = TRUE;
 			}
 			if (!mobike)
 			{
@@ -402,7 +416,7 @@
 						 "deferred");
 					this->ike_sa->set_condition(this->ike_sa, COND_STALE, TRUE);
 					this->initiating.deferred = TRUE;
-					return SUCCESS;
+					return INVALID_STATE;
 				}
 				else if (mobike->is_probing(mobike))
 				{
@@ -436,7 +450,7 @@
 					 "deferred");
 				this->ike_sa->set_condition(this->ike_sa, COND_STALE, TRUE);
 				this->initiating.deferred = TRUE;
-				return SUCCESS;
+				return INVALID_STATE;
 			}
 		}
 
@@ -444,8 +458,9 @@
 		job = (job_t*)retransmit_job_create(this->initiating.mid,
 											this->ike_sa->get_id(this->ike_sa));
 		lib->scheduler->schedule_job_ms(lib->scheduler, job, timeout);
+		return SUCCESS;
 	}
-	return SUCCESS;
+	return INVALID_STATE;
 }
 
 METHOD(task_manager_t, initiate, status_t,
@@ -627,6 +642,7 @@
 	message->set_exchange_type(message, exchange);
 	this->initiating.type = exchange;
 	this->initiating.retransmitted = 0;
+	this->initiating.retransmit_sent = FALSE;
 	this->initiating.deferred = FALSE;
 
 	enumerator = array_create_enumerator(this->active_tasks);
@@ -747,7 +763,7 @@
 	}
 	enumerator->destroy(enumerator);
 
-	if (this->initiating.retransmitted > 1)
+	if (this->initiating.retransmit_sent)
 	{
 		packet_t *packet = NULL;
 		array_get(this->initiating.packets, 0, &packet);
@@ -2346,5 +2362,11 @@
 					"%s.make_before_break", FALSE, lib->ns),
 	);
 
+	if (this->retransmit_base > 1)
+	{	/* based on 1000 * timeout * base^try */
+		this->retransmit_tries_max = log(UINT32_MAX/
+										 (1000.0 * this->retransmit_timeout))/
+									 log(this->retransmit_base);
+	}
 	return &this->public;
 }
